
#include <qapplication.h>
#include <qtranslator.h>
#include <qtextcodec.h>

#include "qtcmd.h"


int main( int argc, char ** argv )
{
	QApplication a( argc, argv );


	QString locale  = QTextCodec::locale();
	locale = locale.section('_', 0,0); // get only the first two characters
	QString appPath = qApp->applicationDirPath();
	QString translationFilePath = appPath.left( appPath.findRev('/')+1 ); // parent dir.for binary file location dir.

	if ( QFileInfo(translationFilePath+".libs").exists() ) // apps. executed from project
		translationFilePath += "bin/";
	else // apps. is installed
		translationFilePath += QString("/share/locale/")+locale+QString("/LC_MESSAGES/");

	debug("translationFilePath=%s", translationFilePath.latin1() );
	// init and sets translations for application
	QTranslator torApp( 0 );
	if ( torApp.load( QString("qtcmd_") + locale, translationFilePath ) )
		a.installTranslator( &torApp );
	// init and sets translations for application settings (plugin)
	QTranslator torAppSetts( 0 );
	if ( torAppSetts.load( QString("qtcmd-setts_") + locale, translationFilePath ) )
		a.installTranslator( &torAppSetts );
	// init and sets translations for view settings (plugin)
	QTranslator torViewSetts( 0 );
	if ( torViewSetts.load( QString("qtcmd-view-setts_") + locale, translationFilePath ) )
		a.installTranslator( &torViewSetts );
	// init and sets translations for text view (plugin)
	QTranslator torTextView( 0 );
	if ( torTextView.load( QString("qtcmd-view-text_") + locale, translationFilePath ) )
		a.installTranslator( &torTextView );
	// init and sets translations for library "uiext"
	QTranslator torLibUiExt( 0 );
	if ( torLibUiExt.load( QString("qtcmd-uiext_") + locale, translationFilePath ) )
		a.installTranslator( &torLibUiExt );
	// init and sets translations for library "utils"
	QTranslator torLibUtils( 0 );
	if ( torLibUtils.load( QString("qtcmd-utils_") + locale, translationFilePath ) )
		a.installTranslator( &torLibUtils );


	QtCmd *mw = new QtCmd( a.argv()[ 1 ], a.argv()[ 2 ] );
	mw->setCaption( "QtCommander" );
	mw->show();

	a.connect( &a, SIGNAL(lastWindowClosed()), &a, SLOT(quit()) );
	return a.exec();
}
